import { Component, OnInit } from '@angular/core';
import { Boilerplate } from 'src/app/models/boilerplate.model';
import { BoilerplateService } from 'src/app/services/boilerplate.service';

@Component({
  selector: 'app-boilerplate-list',
  templateUrl: './boilerplate-list.component.html',
  styleUrls: ['./boilerplate-list.component.scss']
})
export class BoilerplateListComponent implements OnInit {

  boilerplates?: Boilerplate[];
  currentBoilerplate?: Boilerplate;
  currentIndex = -1;
  title = '';

  constructor(private boilerplateService: BoilerplateService) { }

  ngOnInit(): void {
    this.retrieveBoilerplates();
  }

  retrieveBoilerplates(): void {
    this.boilerplateService.getAll()
      .subscribe(
        data => {
          this.boilerplates = data;
          console.log(data);
        },
        error => {
          console.log(error);
        });
  }

  refreshList(): void {
    this.retrieveBoilerplates();
    this.currentBoilerplate = undefined;
    this.currentIndex = -1;
  }

  setActiveBoilerplate(boilerplate: Boilerplate, index: number): void {
    this.currentBoilerplate = boilerplate;
    this.currentIndex = index;
  }


  SearchTitle(): void {
    this.boilerplateService.findByTitle(this.title)
      .subscribe(
        data => {
          this.boilerplates = data;
          console.log(data);
        },
        error => {
          console.log(error);
        });
  }

}
